<?php
header ("Cache-control: no-cache");
header ("Cache-control: no-store");
header ("Pragma: no-cache");

// $Id: forward.php3,v 1.2 2001/11/08 23:04:47 lolz Exp $

// include header-file
include("header.php3");

// include config-file
include("config.php3");

if ($password != "") $password = base64_decode($password);

if($mailaddr) {
  
  // open socket to server and check connection status
  $mailserver=fsockopen($server,$port,&$errno,&$errstr,30);
  if(!$mailserver) {
    print("<b>rymo | Connection | Error</b><hr>
                 Connection failed!<br><br>
                 <a href=\"$restart_url_error\">$restart_link_text</a>");
    exit;
    
    // Connection ok
  }
  else {
    // Welcome Message
    $buffer=fgets($mailserver,512);
    
    // USER
    $buffer="USER $username\n";
    fputs($mailserver,$buffer);
    $buffer=fgets($mailserver,512);
    
    // PASS
    $buffer="PASS $password\n";
    fputs($mailserver,$buffer);
    
    // Authentification OK/ERR
    $buffer=fgets($mailserver,512);
    if (substr($buffer,0,4)=="-ERR") {
      printf("<b>rymo | Authentification | Error</b><hr>
                       Invalid password or username!<br><br>
                       <a href=\"$restart_url_error\">$restart_link_text</a>");
      fclose($mailserver);
      exit;
      
      // Authentification OK
    }
    else {
      
      // QUIT
      $buffer="QUIT\n";
      fputs($mailserver, $buffer);
      $buffer=fgets($mailserver,512);
      
      // close connection
      fclose($mailserver);
      print("<b>rymo | Forward | Send to: $mailaddr</b><hr>");
      
      // New mail...
      $cc_bcc = "";
      if ($mailaddrcc  != "") $cc_bcc = $cc_bcc . "\nCc: $mailaddrcc";
      if ($mailaddrbcc != "") $cc_bcc = $cc_bcc . "\nBcc: $mailaddrbcc";
      $message = stripslashes($message);
      $subject = stripslashes($subject);
      if ($address != ''){
	$mail_sent = mail($mailaddr,$subject,$message . "\n\n-- \n" . $signature,"From: $address\nX-Mailer: rymo $rymo_version - rymo.sourceforge.net$cc_bcc");
      }
      else{
	$mail_sent = mail($mailaddr,$subject,$message . "\n\n-- \n" . $signature,"From: $username@$server\nX-Mailer: rymo $rymo_version - rymo.sourceforge.net$cc_bcc");
      }
      if ($mail_sent == 1){
	print("Message successfully sent!");
      }
      else {
	print("Message not sent, an error occured!");
      }
    }
  }
}
else { // main loop
  
  // open socket to server and check connection status
  $mailserver=fsockopen($server,$port,&$errno,&$errstr,30);
  if(!$mailserver) {
    print("<b>rymo | Connection | Error</b><hr>
                 Connection failed!<br><br>
                 <a href=\"$restart_url_error\">$restart_link_text</a>");
    exit;
    
    // Connection ok
  }
  else {
    // Welcome Message
    $buffer=fgets($mailserver,512);
    
    // USER
    $buffer="USER $username\n";
    fputs($mailserver,$buffer);
    $buffer=fgets($mailserver,512);
    
    // PASS
    $buffer="PASS $password\n";
    fputs($mailserver,$buffer);
    
    // Authentification OK/ERR
    $buffer=fgets($mailserver,512);
    
    if (substr($buffer,0,4)=="-ERR") {
      printf("<b>rymo | Authentification | Error</b><hr>
                       Invalid password or username!<br><br>
                       <a href=\"$restart_url_error\">$restart_link_text</a>");
      fclose($mailserver);
      exit;
      
      // Authentification OK
    }
    else {
      
      // Get mail + headers
      $buffer="RETR $msgid\n";
      fputs($mailserver,$buffer);
      $buffer=fgets($mailserver,512);
      $total = "---Forwarded message:---\n";
      $where = "header";
      
      // Get subject
      for(;;) {
	$buffer=fgets($mailserver,128);
	if(strcasecmp(substr($buffer,0,8),"Subject:")==0) {
	  $subject=substr($buffer,9,strlen($buffer)-9);
	  $subject=htmlspecialchars($subject);
	}
	
	// If end of mail, we break
	if(substr($buffer,0,1)==".") {
	  break;
	}
	
	// If end of headers
	if(strcmp($buffer,"\r\n")==0 || strcmp($buffer,"\n\r")==0 || strcmp($buffer,"\n\n")==0 && $maildate!=0 && $subject!=0 && $fromperson!=0) { 
	  $where = "body";
	}
	
	// Filter some header lines if $filter_forward is true
	if (($where != "body") and ($filter_forward == 1)){
	  if ((substr($buffer,0,7)=="Status:") or (substr($buffer,0,8)=="Content-") or (substr($buffer,0,1)=="\t") or (substr($buffer,0,9)=="Received:") or (substr($buffer,0,9)=="X-Mailer:")){
	    $total = $total;
	  }
	  else{
	    $total = $total . $buffer;
	  }
	      }
	else{
	  $total = $total . $buffer;
	}
      }
      $total = $total . "---End of forwarded message---\n";
      
      // QUIT
      $buffer="QUIT\n";
      fputs($mailserver, $buffer);
      $buffer=fgets($mailserver,512);
      
      // close connection
      fclose($mailserver);
      
    }
  }
  $subject = chop($subject);
  if ($address != '') $who = $address;
  else $who = $username."@".$server;
  print("<b>rymo | Forward | Compose | $who</b><hr>
	   <form action=\"forward.php3\" method=\"post\">
           <table border=0 width=400>
	    <tr align=left bgcolor=\"#C0C0C0\">
             <th>Forward to:</th>
	     <td><input name=\"mailaddr\" size=\"50\"></td>
	    </tr>");
  if ($have_cc == 1) {
    print ("<tr align=left bgcolor=\"#E0E0E0\">
             <th>Cc:</th>
	     <td><input name=\"mailaddrcc\" size=\"50\"></td>
	    </tr>");
  }
  if ($have_bcc == 1) {
    print ("<tr align=left bgcolor=\"#E0E0E0\">
             <th>Bcc:</th>
	     <td><input name=\"mailaddrbcc\" size=\"50\"></td>
	    </tr>");
  }
  print ("
	    <tr align=left bgcolor=\"#E0E0E0\">
	     <th>Subject:</th>
	     <td><input name=\"subject\" value=\"Fwd: $subject\" size=\"50\"></td>
	    </tr>
	    <tr align=left bgcolor=\"#C0C0C0\">
	     <td colspan=2><textarea name=\"message\" rows=20 cols=78 wrap=physical>$total</textarea></td>
	    </tr>
	   </table><br>
	   <input type=\"hidden\" name=\"server\" value=\"$server\">
	   <input type=\"hidden\" name=\"username\" value=\"$username\">
	   <input type=\"hidden\" name=\"password\" value=\"");
  echo base64_encode($password);
  print("\">
           <input type=\"hidden\" name=\"address\"  value=\"$address\">
	   <input type=\"submit\" value=\"Forward now\">
	   </form>");
}

// include buttons
include("buttons.php3");

?>
</body>
</html>
