<?php
header ("Cache-control: no-cache");
header ("Cache-control: no-store");
header ("Pragma: no-cache");

// $Id: login.php3,v 1.6 2001/11/08 23:04:47 lolz Exp $

// include header-file
include("header.php3");

// include config-file
include("config.php3");

// If we come from a first login, we do not need to decode password.
// If user pushed the 'home' button, we need to...
// rymo.php3 had an hidden 'first' field to make the difference.
if ($first != "yes"){
  if ($password != "") $password = base64_decode($password);
}

// open socket to server and check connection status
$mailserver=fsockopen($server,$port,&$errno,&$errstr,30);
if(!$mailserver) {
  print("<b>rymo | Login | Error</b><hr>
	   Connection failed!<br><br>
	   <a href=\"$restart_url_error\">$restart_link_text</a>");
  exit;
  // Connection ok
}
else {
  
  // Welcome Message
  $buffer=fgets($mailserver,512);
  
  // USER
  $buffer="USER $username\n";
  fputs($mailserver,$buffer);
  $buffer=fgets($mailserver,512);
  
  // PASS
  $buffer="PASS $password\n";
  fputs($mailserver,$buffer);
  
  // Authentification OK/ERR
  $buffer=fgets($mailserver,512);
  
  if (substr($buffer,0,4)=="-ERR") {
    printf("<b>rymo | Login | Error</b><hr>
		Invalid password or username!<br><br>
		<a href=\"$restart_url_error\">$restart_link_text</a>");
    fclose($mailserver);
    exit;

    // Authentification OK	
  }
  else {
    if ($address != '') print("<b>rymo | Login | $address</b><hr>\n");
    else print("<b>rymo | Login | $username@$server</b><hr>\n");
    
    // STATUS
    $buffer="STAT\n";
    fputs($mailserver,$buffer);
    $buffer=fgets($mailserver,512);
    $answ=explode(" ", $buffer);
    $mailsum=$answ[1];
    $mailmem=$answ[2];
    
    // QUIT
    $buffer="QUIT\n";
    fputs($mailserver, $buffer);
    $buffer=fgets($mailserver,512);
    
    // close connection
    fclose($mailserver);
    
    // chop's
    $mailsum = chop($mailsum);
    $mailmem = (int)chop($mailmem);
    
    // To use round(x) on php3 and round(x,y) on php4
    $ver = phpversion();
    $vermain = substr($ver, 0, 1);
    
    $unit = $unit1;
    if ($mailmem > 1024){
      if ($vermain == "4") $mailmem = round($mailmem/1024, 1);
      else $mailmem = round($mailmem/1024);
      $unit = $unit2;
    }
    if ($mailmem > 1024){
      if ($vermain == "4") $mailmem = round($mailmem/1024, 1);
      else $mailmem = round($mailmem/1024);
      $unit = $unit3;
    }
    
    // status information
    print("<table border=0 width=400>
  <tr bgcolor=\"#C0C0C0\">
    <td>number of mails</td>
    <th align=left>$mailsum</th>
  </tr>
  <tr bgcolor=\"#E0E0E0\">
    <td>mailboxsize</td>
    <th align=left>$mailmem $unit</th>
  </tr>
</table>");
  }
}

// include buttons
include("buttons.php3");

?>
</body>
</html>
