<?php
header ("Cache-control: no-cache");
header ("Cache-control: no-store");
header ("Pragma: no-cache");

// $Id: mailbox.php3,v 1.18 2001/11/08 23:04:47 lolz Exp $

// include header-file
include("header.php3");

// include config-file
include("config.php3");

if ($password != "") $password = base64_decode($password);

// open socket to server and check connection status
$mailserver=fsockopen($server,$port,&$errno,&$errstr,30);
if(!$mailserver){
  print("<b>rymo | Connection | Error</b><hr>
	   Connection failed!<br><br>
	   <a href=\"$restart_url_error\">$restart_link_text</a>");
  exit;
  
  // Connection ok
}
else {
  // Welcome Message
  $buffer=fgets($mailserver,512);
  
  // USER
  $buffer="USER $username\n";
  fputs($mailserver,$buffer);
  $buffer=fgets($mailserver,512);
  
  // PASS
  $buffer="PASS $password\n";
  fputs($mailserver,$buffer);
  
  // Authentification OK/ERR
  $buffer=fgets($mailserver,512);
  
  if (substr($buffer,0,4)=="-ERR") {
    printf("<b>rymo | Authentification | Error</b><hr>
		Invalid password or username!<br><br>
		<a href=\"$restart_url_error\">$restart_link_text</a>");
    fclose($mailserver);
    exit;
  }
  
  // Authentification OK	
  else {
    if ($address != '') print("<b>rymo | Mailbox | $address</b><hr>");
    else print("<b>rymo | Mailbox | $username@$server</b><hr>");
    
    // STATUS
    $buffer="STAT\n";
    fputs($mailserver,$buffer);
    $buffer=fgets($mailserver,512);
    $answ=explode(" ", $buffer);
    $mailsum=$answ[1];
    $mailmem=$answ[2];
    
    // LIST and get msg's size	
    $ahem = (int) $mailsum;
    for ($q = 1; $q <= $ahem; $q++){
      $buffer="LIST ".$q."\n";
      fputs($mailserver,$buffer);
      $buffer=fgets($mailserver,512);
      $tablo=explode(" ", $buffer);
      $saize[]=$tablo[2];
    }
    
    // Handling more than n mails
    if (!isset($lastdone)) $lastdone=$mailsum;
    
    if ($mailsum > $maxmail){
      $mailtop = $lastdone;
      $mailbot = $mailtop - ($maxmail - 1);
      if ($mailbot < 1) $mailbot = 1;
    }
    else{
      $mailtop = $mailsum;
      $mailbot = 1;
    }
    $lastdone = $mailtop;
    
    echo "\n<b>[ Listing mails ".$mailtop." - ".$mailbot." / ".$mailsum." ]</b><br><br>\n";
    
    // table header
    print("<table border=0 width=100%>
<tr bgcolor=\"#C0C0C0\">
<th>Date</th><th>Size</th><th>From</th><th>Subject</th><th>Read</th>");
    if ($have_delete_mailbox == 1){
      print ("<th>Delete</th>");
    }
    print ("</tr>");
    
    // Load mails
    for($msgid=$mailtop;$msgid>=$mailbot;$msgid--) {
      // TOP mail 0
      $buffer="TOP $msgid 0\n";
      fputs($mailserver,$buffer);
      $buffer=fgets($mailserver,512);
      for(;;) {
	$buffer=fgets($mailserver,512);
	if(strcasecmp(substr($buffer,0,5),"Date:")==0) {
	  $maildate=substr($buffer,6,strlen($buffer)-6);
	}
	if(strcasecmp(substr($buffer,0,5),"From:")==0) {
	  $fromperson=substr($buffer,6,strlen($buffer)-6);
	  $fromperson=htmlspecialchars($fromperson);
	}
	if(strcasecmp(substr($buffer,0,3),"To:")==0) {
	  $toperson=substr($buffer,4,strlen($buffer)-4);
	  $toperson=htmlspecialchars($toperson);
	}
	if(strcasecmp(substr($buffer,0,8),"Subject:")==0) {
	  $subject=substr($buffer,9,strlen($buffer)-9);
	  $subject=htmlspecialchars($subject);
	}
	if(strcmp($buffer,"\r\n")==0 || strcmp($buffer,"\n\r")==0 || strcmp($buffer,"\n\n")==0 && $maildate!=0 && $subject!=0 && $fromperson!=0) {
	  break;
	}
      }
      $msgsize = $saize[$msgid-1];
      
      $datearray = explode(" ", $maildate);
      if (sizeof($datearray) == 6){
	$maildate = $datearray[0]." ".$datearray[1]." ".$datearray[2]." ".$datearray[3]."<br>".$datearray[4]." ".$datearray[5];
      }
      if (sizeof($datearray) == 5){
	$maildate = $datearray[0]." ".$datearray[1]." ".$datearray[2]."<br>".$datearray[3]." ".$datearray[4];
      }
      
      $buffer = explode("&lt;", $fromperson);
      if (sizeof($buffer) == 2){
	$fromperson = implode("<br>&lt;", $buffer);
      }
      
# Remove ISO encoding. We must do it more nicely...in the future!
      $fromperson = str_replace("=?iso-8859-1?Q?", "", $fromperson);
      $fromperson = str_replace("=?ISO-8859-1?Q?", "", $fromperson);
      $subject = str_replace("=?iso-8859-1?Q?", "", $subject);
      $subject = str_replace("=?ISO-8859-1?Q?", "", $subject);
      
      if (strlen($subject) > 32) $subject = substr($subject, 0, 32)."...";
      print("<tr bgcolor=\"#E0E0E0\">
            <td>$maildate</td>
            <td>$msgsize</td>
		    <td>$fromperson</td>
		    <td>$subject</td>
		    <td>
		     <form action=\"readmail.php3\" method=post>
		      <input type=\"hidden\" name=\"server\" value=\"$server\">
                      <input type=\"hidden\" name=\"username\" value=\"$username\">
		      <input type=\"hidden\" name=\"password\" value=\"");
      echo base64_encode($password);
      print ("\">
                      <input type=\"hidden\" name=\"address\"  value=\"$address\">
		      <input type=\"hidden\" name=\"msgid\" value=\"$msgid\">
		      <input type=\"submit\" value=\"read it\">		     
		     </form>
		    </td>");
      if ($have_delete_mailbox == 1){
	print ("<td>
                     <form action=\"delmail.php3\" method=\"post\">
		      <input type=\"hidden\" name=\"server\" value=\"$server\">
		      <input type=\"hidden\" name=\"username\" value=\"$username\">
		      <input type=\"hidden\" name=\"password\" value=\"");
	echo base64_encode($password);
	print("\">
                      <input type=\"hidden\" name=\"address\"  value=\"$address\">
		      <input type=\"hidden\" name=\"msgid\" value=\"$msgid\">
		      <input type=\"submit\" value=\"delete it\">
		     </form>
		    </td>");
      }
      print("</tr>");
      $subject=0;
      $maildate=0;
      $fromperson=0;
      
	while (substr($buffer, 0, 1) != '.') {
	  $buffer=fgets($mailserver,512);
	}
    }
    
    print("</table>\n\n<table border=0><tr>\n");
    
    // QUIT
    $buffer="QUIT\n";
    fputs($mailserver, $buffer);
    $buffer=fgets($mailserver,512);
    
    // close connection
    fclose($mailserver);
    
  }
}

// Button for previous mails
// Are there any previous mails?
if ($mailtop < $mailsum){
  $previous = $lastdone + $maxmail;
  if ($previous > $mailsum) $previous = $mailsum;
?>
<td>
<form action="mailbox.php3" method="post">
<input type="hidden" name="server"   value="<?php echo $server; ?>">
<input type="hidden" name="username" value="<?php echo $username; ?>">
<input type="hidden" name="password" value="<?php echo base64_encode($password); ?>">
<input type="hidden" name="address"  value="<?php echo $address; ?>">
<input type="hidden" name="lastdone" value="<?php echo $previous; ?>">
<input type="submit" value="Previous">
</form>
</td>
<?php
}
else {
  echo "<td>[ No previous  mails ]</td>";
}

// Button for next mails
// Are there more mails?
if ((isset($lastdone)) && ($mailbot > 1)){
  $nextmail = $lastdone - $maxmail;
  if ($nextmail < 1) $nextmail = 1;
?>
<td>
<form action="mailbox.php3" method="post">
<input type="hidden" name="server"   value="<?php echo $server; ?>">
<input type="hidden" name="username" value="<?php echo $username; ?>">
<input type="hidden" name="password" value="<?php echo base64_encode($password); ?>">
<input type="hidden" name="address"  value="<?php echo $address; ?>">
<input type="hidden" name="lastdone" value="<?php echo $nextmail; ?>">
<input type="submit" value="Next">
</form>
</td>
<?php
}
else {
  echo "<td>[ No more mails ]</td>";
}

// Close Previous/Next table
echo "</tr></table>\n\n";

// include buttons
include("buttons.php3");
?>
</body>
</html>
