<?php
header ("Cache-control: no-cache");
header ("Cache-control: no-store");
header ("Pragma: no-cache");

// $Id: readmail.php3,v 1.2 2001/11/08 23:04:47 lolz Exp $

// include header-file
include("header.php3");

// include config-file
include("config.php3");

if ($password != "") $password = base64_decode($password);

// open socket to server and check connection status
$mailserver=fsockopen($server,$port,&$errno,&$errstr,30);
if(!$mailserver) {
  print("<b>rymo | Connection | Error</b><hr>
	   Connection failed!<br><br>
	   <a href=\"$restart_url_error\">$restart_link_text</a>");
  exit;

  // Connection ok
}
else {
  
  // Welcome Message
  $buffer=fgets($mailserver,512);
  
  // USER
  $buffer="USER $username\n";
  fputs($mailserver,$buffer);
  $buffer=fgets($mailserver,512);
  
  // PASS
  $buffer="PASS $password\n";
  fputs($mailserver,$buffer);
  
  // Authentification OK/ERR
  $buffer=fgets($mailserver,512);
  
  if (substr($buffer,0,4)=="-ERR") {
    printf("<b>rymo | Authentification | Error</b><hr>
		Invalid password or username!<br><br>
		<a href=\"$restart_url_error\">$restart_link_text</a>");
    fclose($mailserver);
    exit;
    
    // Authentification OK	
  }
  else {
    if ($address != '') print("<b>rymo | Read mail | $address</b><hr>");
    else print("<b>rymo | Read mail | $username@$server</b><hr>");
    
    // STATUS
    $buffer="STAT\n";
    fputs($mailserver,$buffer);
    $buffer=fgets($mailserver,512);
    $mailsum=substr($buffer,4,1);
    $mailmem=substr($buffer,6,strlen($buffer)-6);
    
    // RETR mail
    $buffer="RETR $msgid\n";
    fputs($mailserver,$buffer);
    $buffer=fgets($mailserver,512);
    
    // Header auslesen
    for(;;) {
      $buffer=fgets($mailserver,512);
      if(strcasecmp(substr($buffer,0,5),"Date:")==0) {
	$maildate=substr($buffer,6,strlen($buffer)-6);
      }
      if(strcasecmp(substr($buffer,0,5),"From:")==0) {
	$fromperson=substr($buffer,6,strlen($buffer)-6);
	$fromperson=htmlspecialchars($fromperson);
      }
      if(strcasecmp(substr($buffer,0,3),"To:")==0) {
	$toperson=substr($buffer,4,strlen($buffer)-4);
	$toperson=htmlspecialchars($toperson);
      }
      if(strcasecmp(substr($buffer,0,8),"Subject:")==0) {
	$subject=substr($buffer,9,strlen($buffer)-9);
	$subject=htmlspecialchars($subject);
      }
      if(strcmp($buffer,"\r\n")==0 || strcmp($buffer,"\n\r")==0 || strcmp($buffer,"\n\n")==0 && $maildate!=0 && $subject!=0 && $fromperson!=0) { 
	break; 
      }
    }
    
    // Header ausgeben
    print("<table border=0 width=400>
		<tr bgcolor=\"#C0C0C0\">
		 <th align=left>Subject:</th>
		 <td colspan=2>$subject</td>
		</tr>
		<tr bgcolor=\"#E0E0E0\">
		 <th align=left>To:</th>
		 <td colspan=2>$toperson</td>
		</tr>
                <tr bgcolor=\"#C0C0C0\">
		 <th align=left>From:</th>
		 <td colspan=2>$fromperson</td>
		</tr>
		<tr bgcolor=\"#E0E0E0\">
                 <th align=left>Date:</th>
		 <td colspan=2>$maildate</td>
		</tr>
		<tr bgcolor=\"#E0E0E0\">
		 <td colspan=3>
		  <pre>");
    for(;;) {
      $buffer=fgets($mailserver,128);
      if(substr($buffer,0,1)==".") {
	break;
      }
      $buffer=htmlentities($buffer);
      print("$buffer");
    }
    print("   </pre>
		 </td>
	        </tr>
		<tr bgcolor=\"#C0C0C0\">
		 <td align=\"center\" colspan=3>
		  <table border=0 cellpadding=0 cellspacing=0>
		   <tr>
		    <td>
                     <form action=\"delmail.php3\" method=\"post\">
		      <input type=\"hidden\" name=\"server\" value=\"$server\">
		      <input type=\"hidden\" name=\"username\" value=\"$username\">
		      <input type=\"hidden\" name=\"password\" value=\"");
    echo base64_encode($password);
    print("\">
                      <input type=\"hidden\" name=\"address\"  value=\"$address\">
		      <input type=\"hidden\" name=\"msgid\" value=\"$msgid\">
		      <input type=\"submit\" value=\"delete\">
		     </form>
		    </td>
		    <td>
                     <form action=\"reply.php3\" method=\"post\">
		      <input type=\"hidden\" name=\"server\" value=\"$server\">
		      <input type=\"hidden\" name=\"username\" value=\"$username\">
		      <input type=\"hidden\" name=\"password\" value=\"");
    echo base64_encode($password);
    print("\">
                      <input type=\"hidden\" name=\"address\"  value=\"$address\">
		      <input type=\"hidden\" name=\"msgid\" value=\"$msgid\">
		      <input type=\"submit\" value=\"reply\">
		     </form>
		    </td>
		    <td>
                     <form action=\"forward.php3\" method=\"post\">
	              <input type=\"hidden\" name=\"server\" value=\"$server\">
		      <input type=\"hidden\" name=\"username\" value=\"$username\">
		      <input type=\"hidden\" name=\"password\" value=\"");
    echo base64_encode($password);
    print("\">
                      <input type=\"hidden\" name=\"address\"  value=\"$address\">
		      <input type=\"hidden\" name=\"msgid\" value=\"$msgid\">
		      <input type=\"submit\" value=\"forward\">
		     </form>
		    </td>
		   </tr>
		  </table> 
		 </td>
		</tr>
	       </table>");
	       
    
    // QUIT
    $buffer="QUIT\n";
    fputs($mailserver, $buffer);
    $buffer=fgets($mailserver,512);
    
    // close connection
    fclose($mailserver);
    
  }
}

// include buttons
include("buttons.php3");

?>
</body>
</html>
